/* before editing this file you may want to blow up your screen... */
 
#include "jukebox.h"

extern void *malloc(size_t size);
extern char *getenv(const char *name);
extern int readplaylist();
extern void interactive();
extern unsigned long int strtoul(const char *nptr, char **endptr, int base);
static void options();
static char *cpystr();
static int my_getopt();
static int readidx();
static void usage();
static void version();
char *inpstr();

                                    /* Note that i do not like nullpointers. All lists are endless chains */

typedef struct scalefile            /* Hier finden sich die Scale-Werte der mp3 files (lautere/leisere Wiedergabe) */
{
  struct scalefile *n;              /* Verkettete-Liste: Zeiger auf nchstes Element */
  char file[MAXLEN];                /* Name der betroffenen Datei */
  int scal;                         /* Scale-Wert (siehe man-page zu mpg123, switch -f) */
} scalefile;

scalefile *scalw, *scala, *scalo;   /* Zeiger auf Anfang, aktuelles-, voriges-Element */
mp3file *mp3w, *mp3a, *mp3o, *mp3p; /* Zeiger auf Anfang, aktuelles-, voriges-Element, Cursor-Position */
struct stat statbuf;

int fcnt = 0;                       /* Anzahl der MP3-Files */
int mxlena = 0;                     /* Lngster artist-string (fr Bildschirmausgabe) */
int mxlent = 0;                     /*          title    "    */
int cpymp3 = 0;                     /* 1: Daten werden in ein Tempfile geschrieben und von dort aus abgespielt */
int mpwait = 0;                     /* 1: Whrend Daten kopiert werden luft der player nicht */
int optch, noerr;                   /* option character, error flag (bit 0 = help, bit 1 = version) */
int scaln = 0;                      /* Anzahl der Scale File Eintrge */
int scaml = 16;                     /* Multiplikator fr Scale-Werte (in 16teln) */
int tmpiu = 0;                      /* 0: Temporres Index File mu noch initialisiert werden */
int cmdcnt = 0;                     /* Anzahl der Kommandozeilenparameter fr player */
int debug = FALSE;                  /* TRUE: Debuginformationen werden auf stderr ausgegeben */
int my_optind, my_optcnt;           /* zhlt globale, lokale und kommandozeilenoptionen; 1: glob. 2: lok. 3: komm. */ 
int fstidx;                         /* my_optind Nummer des 1. indexfiles das tatschlich verwendet wird */
int skeybar = FALSE;                /* TRUE: in der untersten Bildzeile wird die Funtionstastenbelegung gezeigt */
int active = 0;                     /* 0: kein Titel wird gespielt, 1: wird gespielt, 2: soll geladen werden */
int showtime = 0;                   /* 0: keine Zeitanzeige, 1: Restzeit, 2: Spielzeit */
int vtime = 0;                      /* 0: Zeitangabe ungltig, 1: gltig */
time_t timel, times;                /* Lnge des Titels in Sekunden, Startzeit */
char output[MAXLEN];                /* Dateiname des Indexfiles bei der Ausgabe */
char tmpdir[MAXLEN];                /* Verzeichnis fr Tempfiles */
char subidx[MAXLEN];                /* Dateiname des Ersatzindex-Files */
char string[MAXLEN+20];             /* zur allgemeinen Verwendung */
char idxpip[1024];                  /* Shell-Skript */
char scalfn[MAXLEN];                /* Dateiname des Scale-Files */
char confdir[MAXLEN];               /* Konfigurationsverzeichnis (~/.jukebox) */
char gconfn[MAXLEN], lconfn[MAXLEN];/* Globales, lokales Konfigurationsfile */
char *cmdln[20];                    /* Kommandozeilenparameter */
char myarg2[256];                   /* reservierter Speicher fr Optionstring */
char status[160];                   /* Status in der untersten Bilschirmzeile (Titel) */

FILE *in, *gconf, *lconf;           /* Filepointer */

int main(int argc, char **argv)     /* wertet die Kommandozeile aus und liest die Daten ein */
{
  int c;
  cmdln[cmdcnt++] = PLAYER;
  strcpy(tmpdir, TMPDIR);
  strcpy(scalfn, SCALFN);
  strcpy(subidx, "/dev/null");
  strcpy(status, " Press 'H', '?' or <F1> for help");
  noerr = 0;
  scalw = (scalefile *)malloc(sizeof(scalefile));
  scalw->n = scalw;
  scala = scalw;
  scalo = scalw;
  mp3w = (mp3file *)malloc(sizeof(mp3file));
  mp3w->p = mp3w;
  mp3w->n = mp3w;
  mp3a = mp3w;
  mp3o = mp3w;
 
  if (getenv("HOME")) 
    sprintf(confdir, "%s/.jukebox", (char *) getenv("HOME"));
  else
    strcpy(confdir, ".jukebox");
  if (stat(confdir, &statbuf) == -1)
  {
    printf("%s does not exist, do you want to create it now? [Y/n] ", confdir);
    c = getchar();
    if ((c == 10) | (c == 'y') | (c == 'Y'))
    {
      if (mkdir(confdir, 0777) != 0)
      {
        if (errno == EACCES)
          printf("no permission to do this\n");
        else
          printf("can not create directory\n");
        getchar();
      }
    }
  }
  
  options(argc, argv);              /* wertet Kommandozeile aus */
  
  if (noerr == 0)  
  {
    if (readidx())                  /* liest Index-File */
    {
      sprintf(string, "%s/.auto", confdir);
      if (readplaylist(string))     /* liest playlist */
      {
        sprintf(idxpip, "rm -f %s > /dev/null 2> /dev/null", string);
        in = popen(idxpip, "r");
        pclose(in);
        active = 2;
      }
      interactive(); /* startet interaktiven Programmteil */
    }
  }
  else
  {
    if ((noerr & 1) == 1)
      usage();                      /* gibt Hilftext aus */
    if ((noerr & 2) == 2)
      version();                    /* gibt u.a. Versionsnummer aus */
  }
  return 0; 
}

static void options(int argc, char **argv)
{
  static char option[] = "a:A:c:dhi:I:km:o:p:s:t:T:vVx:";
  if (argc == 2)
  {
    if (strstr(argv[1], "--help") != 0)
      noerr = 1;
    if (strstr(argv[1], "--version") != 0)
      noerr = 2;
  }
  if (noerr == 0)
  {
    sprintf(gconfn, DATDIR"/jukeboxrc");
    gconf = fopen(gconfn, "r");
    sprintf(lconfn, "%s/jukeboxrc", confdir);
    lconf = fopen(lconfn, "r");
    my_optind = 0;
    while((optch = my_getopt(argc, argv, option)) != -1)
      switch (optch)
      {
        case 'd':
          debug = TRUE;
          break;
        case 'I':
          if (fstidx < my_optind)
            fstidx = my_optind;
          break;
        case 't':
          strcpy(tmpdir, optarg);
          break;
        case 'A':
        case 'a':
        case 'c':
          break;
        case 'h':
          fstidx = 32000;
          break;
        case 'i':
        case 'k':
        case 'm':
        case 'o':
        case 'p':
        case 's':
        case 'T':
          break;
        case 'v':
        case 'V':
          fstidx = 32000;
          break;
        case 'x':
          strcpy(subidx, optarg);
          break;
        default:
          if (my_optind < 2)
          {
            if (my_optind == 0)
              fprintf(stderr, "error in %s  option: %c  parameter: %s\n", gconfn, optch, optarg);
            else
              fprintf(stderr, "error in %s  option: %c  parameter: %s\n", lconfn, optch, optarg);
            if (optch != '*')
              noerr = (noerr | 1);
            else
              noerr = (noerr | 2);
          }
          else
            noerr = (noerr | 1);
      }
    if (noerr == 0)
    {
      my_optind = 0;
      while((optch = my_getopt(argc, argv, option)) != -1)
        switch (optch)
        {
          case 'A':
            cmdcnt = 1;
          case 'a':
            cmdln[cmdcnt++] = cpystr(optarg);
            break;
          case 'c':
            if (strcmp(optarg, "off") == 0)
              cpymp3 = 0;
            else
            {
              cpymp3 = 1;
              if (strcmp(optarg, "wait") == 0)
                mpwait = 1;
              else
              {
                mpwait = 0;
                if (strcmp(optarg, "on") != 0)
                {
                  fprintf(stderr, "Use '-c on', '-c wait' or '-c off'\n");
                  noerr = (noerr | 1);
                }
              }
            }
            break;
          case 'd':
            break;
          case 'h':
            noerr = (noerr | 1);
            break;
          case 'I':
            if (fstidx >= my_optind)
            {
              sprintf(idxpip, "cp /dev/null %s/jukebox.index", tmpdir);
              in = popen(idxpip, "r");
              pclose(in);
            }
          case 'i':
            if (tmpiu == 0)
            {
              sprintf(idxpip, "cp /dev/null %s/jukebox.index", tmpdir);
              in = popen(idxpip, "r");
              pclose(in);
              tmpiu = 1;
            }
            if ((noerr == 0) & (fstidx <= my_optind))
            {
              if (debug)
                fprintf(stderr, "\n%s - %i, %i\n", optarg, fstidx, my_optind);
              sprintf(idxpip, "if test -f %s; then if test -f `awk -v FS='' 'NR==1{print $5}' %s`; then echo 'scanning '%s >&0; cat %s >> %s/jukebox.index; fi;else if test -d %s; then echo 'scanning '%s >&0; for path in %s/*.mp3; do if test -f $path; then file=`echo $path | awk -v FS='/' '{print $NF}'`; if grep -i $file\\$ %s 2>&1 > /dev/null; then echo `grep -i $file\\$ %s`''$path | awk -v FS='' '{printf \"%%s%%s%%s%%s%%s%%c\",$1,$2,$3,$4,$6,10}' >> %s/jukebox.index; else mp3info -f \"%%IT%%a%%t%%!E$file%%IE%%m%%s%%f\" $path >> %s/jukebox.index || echo \"$file00\"$path >> %s/jukebox.index; fi; fi; done; fi; fi\n", optarg, optarg, optarg, optarg, tmpdir, optarg, optarg, optarg, subidx, subidx, tmpdir, tmpdir, tmpdir);
              in = popen(idxpip, "r");
              pclose(in);
              if (debug)
              {
                fprintf(stderr, "%s\n", idxpip);
                getchar();
              }
            }
            break;
          case 'k':
            skeybar = TRUE;
            break;
          case 'm':
            scaml = strtoul(optarg, NULL, 10);
            if (scaml == 0)
              scaml = 16;
            break;
          case 'o':
            strcpy(output, optarg);
            break;
          case 'p':
            cmdln[0] = optarg;
            break;
          case 's':
            strcpy(scalfn, optarg);
            break;
          case 't':
            break;
          case 'T':
            if (strcmp(optarg, "off") == 0)
              showtime = 0;
            else if (strcmp(optarg, "remain") == 0)
              showtime = 1;
            else if (strcmp(optarg, "elapsed") == 0)
              showtime = 2;
            break;
          case 'v':
          case 'V':
            noerr = (noerr | 2);
            break;
          case 'x':
            break;
        }
    }
	if (gconf > 0)
      fclose(gconf);
	if (lconf > 0)
      fclose(lconf);
  }            
}

char *cpystr(char * const tmpstr)

{
  int i;
  char *string;
  string = (char *)malloc(strlen(tmpstr)+1);
  for (i=0; i<=strlen(tmpstr); i++)
    string[i] = tmpstr[i];
  return string;
} 

static int my_getopt(int argc, char * const argv[], const char *optstring)
{
  int optch = -1;
  int i, j;
  char *myargs = NULL;                /* Puffer fr bergabeparmeter */
  if (my_optind++ == 0)
  {
	if (gconf > 0)
      rewind(gconf);
	if (lconf > 0)
      rewind(lconf);
    my_optcnt = 0;
    optind = 0;
    if (debug)
      fprintf(stderr, "\nglobal configuration\n");
  }
  if (my_optcnt == 0)
  {
	if (gconf > 0)
    {
      do
      {
        do
        {
          optch = fgetc(gconf);
        } while((optch < 32) & (optch >= 0));
        myargs = fgets(string, MAXLEN, gconf);
        if (strlen(string) >= MAXLEN-1)
        {
          fprintf(stderr, "line exceeds maximum lenght (MAXLEN) in %s\n", gconfn);
          fprintf(stderr, "  option: %c  parameter: %s\n", optch, string);
          noerr = noerr | 2;
        }
      } while(optch == '#');
      if (optch == -1)
      {
        my_optcnt = my_optcnt+1;
        if (debug)
          fprintf(stderr, "\nlocal configuration\n");
      }
	}
	else
      my_optcnt = my_optcnt+1;
  }
  if (my_optcnt == 1)
  {
	if (lconf > 0)
    {
      do
      {
        do
        {
          optch = fgetc(lconf);
        } while((optch < 32) & (optch >= 0));
        myargs = fgets(string, MAXLEN, lconf);
        if (strlen(string) >= MAXLEN-1)
        {
          fprintf(stderr, "line exceeds maximum lenght (MAXLEN) in %s\n", lconfn);
          fprintf(stderr, "  option: %c  parameter: %s\n", optch, string);
          noerr = noerr | 2;
        }
      } while(optch == '#');
      if (optch == -1)
      {
        my_optcnt = my_optcnt+1;
        if (debug)
          fprintf(stderr, "\ncommandline parameters\n");
      }
	}
	else
      my_optcnt = my_optcnt+1;	
  }
  if (myargs == NULL)
    myargs = "none";
  optarg = myarg2;
  j = 0;
  for (i=0; i<=strlen(myargs); i++)
    if (myargs[i] > ' ')
      optarg[j++] = myargs[i];
  optarg[j] = 0;
  if (my_optcnt == 2)
    optch = getopt(argc, argv, optstring);
  if (optarg == NULL)
    optarg = "none";
  if (debug)
    fprintf(stderr, "%c %s\n", optch, optarg);
  return optch;
}

static int readidx(void)
{
  int inter = FALSE;
  int error = FALSE;
  FILE *out;
  if ((in = fopen(scalfn, "r")) != NULL)
  {
    while(1)
    {
      inpstr(scala->file, in);
      scala->scal = strtoul(inpstr(string, in), NULL, 10);
      if (scala->file[0] == 0)
        break;
      scaln = scaln+1;
      scalo = scala;
      scala = (scalefile *)malloc(sizeof(scalefile));
      scalo->n = scala;
    }
    fclose(in);
    scalo->n = scalw;
  }
  sprintf(idxpip, "cat %s/jukebox.index | sort | uniq", tmpdir);
  if ((in = popen(idxpip, "r")) == NULL)
  {
    fprintf(stderr, "\nerror while opening index-file(s)\n");
    error = TRUE;
  }
  else
  {
    while(1)
    {
      mp3a->pos = 0;
      inpstr(mp3a->artist, in);
      inpstr(mp3a->title, in);
      mp3a->min = strtoul(inpstr(string, in), NULL, 10);
      mp3a->sec = strtoul(inpstr(string, in), NULL, 10);
      inpstr(mp3a->fname, in);
      mp3a->scale = 32768;
      if (scaln > 0)
      {
        scala = scalw;
        do
        {
          if (strstr(mp3a->fname, scala->file))
            mp3a->scale = scala->scal;
          scala = scala->n;
        } while (scala != scalw);
      }
      if (strlen(mp3a->artist) > mxlena)
        mxlena = strlen(mp3a->artist);
      if (strlen(mp3a->title) > mxlent)
        mxlent = strlen(mp3a->title);
      if (mp3a->fname[0] == 0)
        break;
      if (mp3a->artist[0] != '~')
      {
        fcnt = fcnt+1;
        mp3o = mp3a;
        mp3a = (mp3file *)malloc(sizeof(mp3file));
        mp3a->p = mp3o;
        mp3o->n = mp3a;
      }
    }
    pclose(in);
    if (mp3w->fname[0] != 0)
    {
      mp3o->n = mp3w;
      mp3w->p = mp3o;
      sync();
      if (output[0] == 0)
      {
        inter = TRUE;
      }
      else
      {
        if ((out = fopen(output, "wt")) == NULL)
        {
          printf("Sorry, can not open %s\n", output);
        }
        else
        {
          mp3a = mp3w;
          while (mp3a->n != mp3w)
          {
            fprintf(out, "%s%s%i%i%s\n", mp3a->artist, mp3a->title, mp3a->min, mp3a->sec, mp3a->fname);
            mp3a = mp3a->n;
          }
          fclose(out);
        }
      }
    }
    else
      fprintf(stderr, "Sorry, nothing to do...\n");    
  }
  return inter;
}

static void usage(void)
{
  printf("\n%s	Version: %i.%i.%i\n", PTITLE, MAJV, MINV, PATV);
  printf("\nOptions: -a param.  optional parameter for player");
  printf("\n         -A param.  same as -a, but do not use previosly given parameters");
  printf("\n         -c on/wait/off copy/do not copy files before playing (see README)");
  printf("\n         --help\n         -h         this text");
  printf("\n         -i file    path and name of an index-file or directory contaning");
  printf("\n                    MP3-files");
  printf("\n         -I file    same as -i, but ignore paths and directories previously");
  printf("\n                    given by -i and -I");
  printf("\n         -k         show keybar");
  printf("\n         -o file    create index-file and exit");
  printf("\n         -p player  your favourite mp3-player");
  printf("\n         -s file    path and name of the scale-file");
  printf("\n         -t path    path for tempfiles");
  printf("\n         -T remain/elapsed/off display remaining time, display elapsed time,");
  printf("\n                    do not display time of a running title");
  printf("\n         --version\n         -v         print version and settings");
  printf("\n         -x file    path and name of sub-index-file\n");
  printf("\n-a and -i can be used several times\n\n");
}  

static void version(void)

{
  int i;
  printf("\n%s	Version: %i.%i.%i\n", PTITLE, MAJV, MINV, PATV);
  printf("	Player: %s  (Default: %s)\n", cmdln[0], PLAYER);
  printf("	Parameters: ");
  for (i=1; i<cmdcnt; i++)
    printf("%s ", cmdln[i]);
  printf("\n	Scale-File: %s  (Default: %s)\n", scalfn, SCALFN);
  printf("  Scale-Multiplier (1/16): %i\n", scaml);
  printf("	Temp-Dir: %s  (Default: %s)\n", tmpdir, TMPDIR);
  printf("	Maximum Lenght For Strings: %i\n\n", MAXLEN);
}

char *inpstr(char *string, FILE *in)
                                    /* Zerlegt die Zeilen des Index-Files in einzelne Strings */
{
  int i;
  for (i = 0; i < MAXLEN; ++i)
  {
    string[i] = fgetc(in);
	if (string[i] == '')
	   string[i] = 39;
    if ((string[i] == 9) || (string[i] == 10) || (string[i] == '') || (string[i] == -1))
      break;
  }
  string[i] = 0;
  return string;
}
